/*
 * $Id: Corppq.c,v 1.4 2005-10-17 15:11:43 tonydodd Exp $
 *
 * $Log: not supported by cvs2svn $
 * Revision 1.2  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.1  1996/02/15 01:29:28  scotty
 * Initial revision
 *
 */
#include "Corpinc.h"



#define SERVER 1

#define MAXQSTRING   50
#define MAXQTOK     500
#define MAXPD       100



struct loc {
   sara_ulong  code;
   WORDNO      w0;
   WORDNO      nw;
};




int   nt;


struct {
   int   val;
   int   scope;
} stack[MAXPD];

int   st;



int       TokeniseQuery(xairo_uchar *);
BOOL      GetToken(xairo_uchar **, int *);
BOOL      bOKName(xairo_uchar);
void      GetName(char **, char *);
void      GetNameW(xairo_uchar **, xairo_uchar *);
void      GetString(xairo_uchar **, xairo_uchar *, xairo_uchar);
BOOL      ParseQuery(void);
void      pushop(int, int);
int       pop(int);
void      pusharg(int);
BOOL      bPrec(int, int);
int       ParseTag(int *);
int       prec(int);
void      PrintQuery(BOOL, int, int);
struct stream *BuildQuery(BOOL, int);
int       optype(xairo_uchar);
int       GetInt(xairo_uchar *);
void      GetLoc(xairo_uchar **, struct loc *);
void      Defrob(char *, char *);
BOOL      LetterChar(int,unsigned char);
BOOL      LetterCont(int,unsigned char,unsigned char*);
BOOL	SpaceChar(unsigned char);
int       enclitic(char *);
BOOL ParseXMLQuery(xairo_uchar*);

extern int ClassifyPOS(char*);
extern struct stream *BuildXMLQuery(const xairo_uchar*,char*);

BOOL	  bLemma;



void FlattenStream(struct stream *s)
{
   struct stream *t[MAXOPS];
   int            i,
                  j,
                  k=0;

   int nw=0;
   for (i = 0; i < s->ops; i++) {
      if (s->op[i]->type == TY_SEQ && s->type == TY_SEQ) {
		  for (j = 0; j < s->op[i]->ops; j++) {
			  nw+=s->op[i]->op[j]->nw+1;
            t[k++] = s->op[i]->op[j];
		  }
      } else {
         t[k++] = s->op[i];
		 nw+=s->op[i]->nw+1;
	  }
   }
   s->ops = k;
   if (s->type==TY_SEQ) s->nw=nw-1;

   for (i = 0; i < k; i++)
      s->op[i] = t[i];
}




sara_long SolveX(char *name, xairo_uchar *cql, int *ntx,char* err)
{
   sara_long      n;
   struct stream *s;

   bInt = FALSE;

   NewQuery();
   FreeStreams();


#if 0
   if (!ParseXMLQuery(cql)) return -1;
 
 
   s = BuildQuery(argstack[0].bHeap, argstack[0].arg);
#else
   err[0]=0;
   s=BuildXMLQuery(cql,err);
   if (err[0]) return -1;
#endif
   if (bStreamErr)
      return -4;
   if (s == NULL)
      return 0;

   qs = *s;

   n = SaveQueryFile(s, name, ntx);

   if (n <= 0)
      qs.type = 0;

   return n;
}


sara_long colloc_score(char *name, xairo_uchar *cql, int kwin1, int kwin2, int* ns)
{
   FILE             *f;
   struct locent1    l;
   sara_long         ks = 0;
   struct stream    *s=NULL;


   *ns=0;
   s=MakeLemmaStream(cql);
   if (s == NULL)
      return 0;

   RewindStream(s);
   XAdvanceStream(s);

   f = fopen(GetQPath(name), "r");

   while (fread(&l, sizeof(l), 1, f) == 1) {
/*      fix_locent1(&l, 1); */
      ks += xscore(&l, s, kwin1,kwin2);
   }

   fclose(f);
   RewindStream(s);
   *ns=0;
   while (XAdvanceStream(s)) (*ns)++;
   return ks;
}

BOOL      Frob(char **, char **);
char      frobuff[MAXPHRASE];








