/*
 * $Id: Corpwl.c,v 1.5 2005-12-12 19:49:54 tonydodd Exp $
 *
 * $Log: not supported by cvs2svn $
 * Revision 1.1  1996/01/30 20:47:53  scotty
 * Initial revision
 *
 */
#include "Corpinc.h"


int MergeWords(struct regexpnew *re,xairo_uchar*,char*);
int MergeWordsA(struct regexpnew *re,char*,xairo_uchar*,xairo_uchar*,BOOL);


// Do this properly with Unicode
BOOL rawchar(xairo_uchar w)
{
	if ('a'<=w && w <= 'z') return TRUE;
	if ('A'<=w && w <= 'Z') return TRUE;
	return FALSE;
}


void PString(xairo_uchar* a,xairo_uchar* p)
{
	while (*a && rawchar(*a)) *p++=*a++;
	*p=0;
}



int WoL(xairo_uchar *patt,BOOL bCS,char* path)
{
   struct regexpnew *re=NULL;
	xairo_uchar pre[MAXWORD];
   PString(patt,pre);
   re = ParseRegExp(patt,bCS); 
   if (re==NULL) return 0; /* should give an error as this means 'can't parse' */
   wcscpy(qs.xword, patt);
   qs.type = TY_FILE;
   qs.first = 0;
   qs.ff = 0;
   return MergeWords(re,pre,path);
}

int WoLA(xairo_uchar *patt,xairo_uchar* att,xairo_uchar* elt,BOOL bG,char* path)
{
   struct regexpnew *re=NULL;
   re = ParseRegExp(patt,TRUE); 
   if (re==NULL) return 0; /* should give an error as this means 'can't parse' */
   wcscpy(qs.xword, patt);
   qs.type = TY_FILE;
   qs.first = 0;
   qs.ff = 0;
	return MergeWordsA(re,path,att,elt,bG);
}




struct stream *MakeRegExpStreamW(xairo_uchar *patt,BOOL bCS)
{
   int            n;
   FILE          *f;
   struct stream *s;
   sara_long      ss;

   char tn[_MAX_PATH];
   char* tn0=_tempnam(tmppath,"wl");
   strcpy(tn,tn0);
   n = WoL(patt,bCS,tn);
   if (n == 0) return NULL; // oy clear up that file!

   f = fopen(tn, "rb");
   s = GrabStream();
   s->type = TY_FILE;

   fseek(f, 0, SEEK_END);
   ss = ftell(f);
   rewind(f);

   s->count = (int) ss / sizeof(struct locent1);
   s->first = 0;
   s->ff = 0;
   s->last = (int) s->count % maxiloc;
   s->lf = (int) s->count / maxiloc;
   s->handle = f;
   s->wc = 1;

   return s;
}

struct stream *MakeRegExpStreamA(xairo_uchar *patt,xairo_uchar* att,xairo_uchar* elt,BOOL bG)
{
   int            n;
   FILE          *f;
   struct stream *s;
   sara_long      ss;
   char tn[_MAX_PATH];
   char* tn0=_tempnam(tmppath,"wl");
   strcpy(tn,tn0);
      n = WoLA(patt,att,elt,bG,tn);
      if (n == 0)
	 return NULL;
   

   f = fopen(tn, "r");
   s = GrabStream();
   s->type = TY_FILE;

   fseek(f, 0, SEEK_END);
   ss = ftell(f);
   rewind(f);

   s->count = (int) ss / sizeof(struct locent1);
   s->first = 0;
   s->ff = 0;
   s->last = (int) s->count % maxiloc;
   s->lf = (int) s->count / maxiloc;
   s->handle = f;
   s->wc = 1;

   return s;
}



int       rebuff[MAXRE];
int       nre;

int WoL1(xairo_uchar *regexp)
{
	extern ip;
   int            i; int x1, x2;
   int            k = 0;
   xairo_uchar           pre[MAXWORD];
   struct regexpnew *re;
   int fr, fo;
   xairo_uchar          wd[MAXWORD];
   re = ParseRegExp(regexp,FALSE);
   if (re==NULL) return 0;
   PString(regexp, pre); 
	MkLC(pre);
	MkNorm(pre);

   if (!GetLims(fDict, 0, dicthead.ndix - 1,pre, &x1, &x2)) return 0;
 
   for (i = x1; i <= x2; i++) {

	      GetDictEntry(fDict, i, wd, sizeof(wd)/sizeof (xairo_uchar), &fr, &fo);

      if (wd == NULL)
         break;
      if (pMatch(wd, re)) {
         rebuff[k] = i;
         k++;
         if (k > MAXRE)
            return -2;
      }
   }
   nre = k;
   return k;
}


void WoL2(int k, xairo_uchar *wd, int swd, sara_long *freq, sara_long *forms)
{
   GetDictEntry(fDict, rebuff[k], wd, swd, freq,forms);

   return;
}
