#pragma once

XAIRO_NAMESPACE_BEGIN

class CParameters
{
public:
	CParameters(CXairoServer* s);
	~CParameters();
	bool Read(const char*);
	const xairo_uchar* exppath(param,const xairo_uchar*);
	const xairo_uchar* Param(param p) {return param_vals[p];}
private:
	CXairoServer* m_server;
	void SetParam(const xairo_uchar*,const xairo_uchar*);
	static const xairo_uchar* param_names[PARAM_MAX];
	const xairo_uchar* param_vals[PARAM_MAX];
	const xairo_uchar* m_root;
};

XAIRO_NAMESPACE_END
