#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN


class CXairoCollocate : public CXairoICollocate
{
public:
	CXairoCollocate(int d,int p,int f,int h,double s,CXairoServer* sv):m_d(d), m_p(p), hits(h),m_freq(f), score(s), m_server(sv) {}
	~CXairoCollocate();
	XAIRO_API_EXPORT CXairoIWord* getWord();
	XAIRO_API_EXPORT int getHits() {return hits;}
	XAIRO_API_EXPORT double getScore() {return score;}
private:
	int m_p, m_d, m_freq;
	int hits;
	double score;
	CXairoServer* m_server;
};

XAIRO_NAMESPACE_END
