#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN




class CXairoExtendedForm : public CXairoIExtendedForm
{
public:
	CXairoExtendedForm(unsigned int i,CXairoServer* s):
	  m_i(i),m_server(s) {}
	XAIRO_API_EXPORT const xairo_uchar* getAdditionalKey(const xairo_uchar* key);
	XAIRO_API_EXPORT const xairo_uchar* getNorm();
	XAIRO_API_EXPORT const xairo_uchar* getText();
	XAIRO_API_EXPORT const xairo_uchar* getData(int);
	XAIRO_API_EXPORT CXairoIExtendedForm::type getType();
	int getId() {return m_i;}

private:
	unsigned int m_i;
	CXairoServer* m_server;

};

XAIRO_NAMESPACE_END
