#define XAIRO_SERVER_API

#include "SServer.h"
#include "XairoStubServer.h"
#include "XairoImplementation.h"

XAIRO_NAMESPACE_BEGIN



CXairoInterface* CXairoImplementation::getServer(const CXairoIParameters* xp)
{
	CXairoServer* s=CXairoServer::getServer();
	bool b=s->Init(xp);
	if (b) return s;
	delete s;
	return NULL;
}

CXairoIStubServer* CXairoImplementation::getStubServer()
{
	CXairoServer* s=CXairoServer::getServer();
	CXairoStubServer* ss=new CXairoStubServer(s);
	return ss;
}

CXairoIStubServer* CXairoImplementation::getStubServer(CXairoInterface* s)
{
// The constructor for the stub server should use a CXairoInterface object but that
// would involve too many changes just now
	CXairoStubServer* ss=new CXairoStubServer((CXairoServer*) s);
	return ss;
}

XAIRO_NAMESPACE_END
