#pragma once

#include "../XairoHeader.h"

#include "KDB.h"
#include "XairoWord.h"

XAIRO_NAMESPACE_BEGIN


class CXairoWordList : public CXairoIWordList
{
public:
	CXairoWordList(CDBKey*,int,CXairoServer*);
	CXairoWordList(const xairo_uchar*,CXairoServer*);
	~CXairoWordList(void);
	XAIRO_API_EXPORT int getCount();
	XAIRO_API_EXPORT CXairoWord* getWord(int);
	const xairo_uchar* getId();
private:
	CDBKey* m_key;
	CXairoServer* m_server;
	int m_dict;
};

XAIRO_NAMESPACE_END
