#pragma once

//#include <unicode/brkiter.h>
//#include <unicode/coll.h>

XAIRO_NAMESPACE_BEGIN

class CLanguage
{
public:
	CLanguage(CXairoServer*);
	~CLanguage(void);
	UnicodeString MkNorm(UnicodeString); // all these are bad and could overflow
	UnicodeString MkLC(UnicodeString);
	int Tokenise(UnicodeString,UnicodeString*&);
	bool Load(const char*);
	const char* GetDefault() {return m_wblocale;}
private:
	CXairoServer* m_server;
	BreakIterator *m_brit;
	Collator* m_collator;
	const char* m_wblocale; 
	xairo_uchar	*m_wbrules;
};

XAIRO_NAMESPACE_END
