#include "stdafx.h"
#include "XairoProxyAttributeValue.h"
#include "XairoProxyCorpusTextFilter.h"



CXairoProxyAttributeValue::~CXairoProxyAttributeValue(void)
{
}

int CXairoProxyAttributeValue::getFilteredFrequency(const CXairoICorpusTextFilter* f)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=((CXairoProxyCorpusTextFilter*) f)->getId();
	s=RPCCall(L("AttributeValue_getFilteredFrequency"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}
