#include "stdafx.h"
#include "XairoProxyCorpusTextList.h"
#include "XairoProxyCorpusText.h"
#include "XairoProxyCorpusTextFilter.h"

CXairoProxyCorpusTextList::CXairoProxyCorpusTextList(CXairoProxyServer* s):m_server(s)
{
}

CXairoProxyCorpusTextList::~CXairoProxyCorpusTextList(void)
{
}

int CXairoProxyCorpusTextList::getCount()
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("CorpusTextList_getCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

CXairoICorpusText* CXairoProxyCorpusTextList::getCorpusText(int i)
{
/*
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("CorpusTextList_getCorpusText"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return new CXairoProxyCorpusText(RPCStringParam(d,0),m_server);
*/
	return new CXairoProxyCorpusText(i,m_server);

}

CXairoICorpusTextFilter* CXairoProxyCorpusTextList::getCorpusTextFilter(int nt,int* t)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_VECTOR; x[0].nvec=nt; x[0].vec=t;
 	s=RPCCall(L("CorpusTextList_getCorpusTextFilter"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return new CXairoProxyCorpusTextFilter(RPCStringParam(d,0),m_server);
}

CXairoICorpusTextFilter* CXairoProxyCorpusTextList::getCorpusTextFilter(CXairoIGrammar::Partition*,int)
{
	return NULL;
}

