#include "stdafx.h"
#include "XairoProxyHit.h"
#include "XairoProxyCorpusText.h"
#include "XairoProxyTextEntity.h"

#include "RPCUtils.h"

using namespace PROXY_UTILS;

CXairoProxyHit::~CXairoProxyHit(void)
{
}

CXairoICorpusText* CXairoProxyHit::getCorpusText()
{
/*	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_d;
	s=RPCCall(L("Hit_getCorpusText"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return new CXairoProxyCorpusText(RPCIntParam(d,0),m_server);
*/
	return new CXairoProxyCorpusText(m_d,m_server);
}

CXairoITextEntity* CXairoProxyHit::getTextEntity()
{
	return new CXairoProxyTextEntity(m_url);
}

const xairo_uchar* CXairoProxyHit::getText(int sc,int max)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[4];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=m_i;
	x[2].t=XMLRPC_I4; x[2].i=sc;
	x[3].t=XMLRPC_I4; x[3].i=max;
	s=RPCCall(L("Hit_getText"),4,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}


