#pragma once
#include "XairoProxyServer.h"

class CXairoProxyHit :
	public CXairoIHit
{
public:
	CXairoProxyHit(const xairo_uchar* id,int i,const xairo_uchar* u,int d,int f,
		const xairo_uchar* url,unsigned int c1,unsigned int c2,CXairoProxyServer* s):
	m_id(id),m_i(i),m_u(u),m_d(d),m_f(f),m_url(url),m_seq1(c1),m_seq2(c2),m_server(s) {}
	~CXairoProxyHit(void);
	const xairo_uchar* getText(int,int);
	CXairoICorpusText* getCorpusText();
	const xairo_uchar* getUnit() {return m_u;}
	CXairoITextEntity* getTextEntity();
	unsigned int getCursorStart() {return m_seq1;}
	unsigned int getCursorEnd() {return m_seq2;}
private:
	const xairo_uchar* m_u, *m_url, *m_id;
	int m_d, m_f, m_i;
	unsigned int m_seq1, m_seq2;
	CXairoProxyServer* m_server;
};
