#include "stdafx.h"
#define XAIRA_PROXY_DLL 1
#include "../XairoHeader.h"
#include "XairoProxyServer.h"


CXairoInterface* CXairoProxyImplementation::getLocalServer(CXairoInterface* s)
{
	CXairoProxyServer* p=new CXairoProxyServer(s);
	bool b=p->Configure(true,"",0,NULL);
	return p;
}


CXairoInterface* CXairoProxyImplementation::getRemoteServer(const char* url,int port,CXairoIBootMonitor* bm)
{
    XMLPlatformUtils::Initialize();
	CXairoProxyServer* p=new CXairoProxyServer();
	bool b=p->Configure(false,url,port,bm);
	if (b) return p;
	delete p;
	return NULL;
}

CXairoInterface* CXairoProxyImplementation::getCustomServer(CXairoTransport* t,CXairoIBootMonitor* bm)
{
    XMLPlatformUtils::Initialize();
	CXairoProxyServer* p=new CXairoProxyServer();
	bool b=p->Configure(t,bm);
	if (b) return p;
	delete p;
	return NULL;
}
