#pragma once

XAIRO_NAMESPACE_BEGIN


struct _xb {
	bool bUsed;
	int page;
	int t;
	xara_loc* data;
};


class CLocs
{
public:
	CLocs(CXairoServer*);
	~CLocs(void);
	bool Load();
	xara_loc* GetLoc(int);
	int GetMaxLoc();  // get exact figure here
	void GetSize(__int64&,__int64&);

private:
	CXairoServer* m_server;
	void InitBuffers(int);
	xara_loc_hdr m_loc_hdr;
	FILE** m_fLocs;
	xara_loc_page* m_loctab;
	int m_maxiloc, m_npages;
	xara_loc* ReadIndex(int);
	xara_loc* Buffered(int);
	xara_loc* FreeBuffer(int);
	xara_loc* GetFreeBuffer(int);
	void ReadPage(int,xara_loc*);
	_xb* m_buffer;
	int m_nbuffer;
	int m_nt;
};

XAIRO_NAMESPACE_END
