#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN

class CXairoAddkeyValue : public CXairoIAddkeyValue
{
public:
	CXairoAddkeyValue(const xairo_uchar* val,int freq):
	  m_val(val),m_freq(freq) {}
public:
	~CXairoAddkeyValue(void);
	XAIRO_API_EXPORT const xairo_uchar* getValue() {return m_val;}
	XAIRO_API_EXPORT int getFrequency() {return m_freq;}
private:
	const xairo_uchar* m_val;
	int m_freq;
};

XAIRO_NAMESPACE_END