#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN


class CXairoAttributeValueList : public CXairoIAttributeValueList
	{
	public:
		CXairoAttributeValueList(CDBKey*,const CXairoIGrammar::Codebook*,CXairoServer*);
		CXairoAttributeValueList(const xairo_uchar* id,const xairo_uchar* cbid,CXairoServer*);
		~CXairoAttributeValueList();
		XAIRO_API_EXPORT int getCount();
		XAIRO_API_EXPORT class CXairoIAttributeValue* getAttributeValue(int);
		const xairo_uchar* getId();
	private:
		CDBKey *m_key;
		CXairoServer* m_server;
		const CXairoIGrammar::Codebook *m_cb;
	};

XAIRO_NAMESPACE_END
