#pragma once
#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN

class CXairoCorpusTextFilter :
	public CXairoICorpusTextFilter
{
public:
	CXairoCorpusTextFilter(const xairo_uchar*,CXairoServer*);
	CXairoCorpusTextFilter(CDBKey*,CXairoServer*);
	~CXairoCorpusTextFilter();
	XAIRO_API_EXPORT const xairo_uchar* serialize() {return getId();}
	const xairo_uchar* getId();
	int getTexts(int*&);
	int OnOffMap(int*&);

private:
	bool m_bOwns;
	CDBKey* m_key;
	CXairoServer* m_server;

};

XAIRO_NAMESPACE_END