#pragma once

#include "../XairoHeader.h"

#include "XairoCorpusText.h"

XAIRO_NAMESPACE_BEGIN


class CXairoCorpusTextList : public CXairoICorpusTextList
{
public:
	CXairoCorpusTextList(CXairoServer*);
	~CXairoCorpusTextList(void);
	XAIRO_API_EXPORT int getCount();
	XAIRO_API_EXPORT CXairoICorpusText* getCorpusText(int);
	XAIRO_API_EXPORT CXairoICorpusTextFilter* getCorpusTextFilter(int,int*);
	XAIRO_API_EXPORT CXairoICorpusTextFilter* getCorpusTextFilter(CXairoIGrammar::Partition*,int);
private:
	CXairoServer* m_server;
};

XAIRO_NAMESPACE_END
