#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN




class CXairoForm : public CXairoIForm
{
public:
//	CXairoForm(xara_form*,CXairoServer*);
	CXairoForm(int,int,int,CXairoServer*);
	CXairoForm(int,CXairoServer*);
	CXairoForm(const xairo_uchar*,CXairoServer*);
	~CXairoForm();
	XAIRO_API_EXPORT int getFrequency() {return m_form->freq;}
	XAIRO_API_EXPORT const xairo_uchar* getAdditionalKey(const xairo_uchar*);
	XAIRO_API_EXPORT const xairo_uchar* getNorm();
	XAIRO_API_EXPORT const xairo_uchar* getText();
	XAIRO_API_EXPORT int getFilteredFrequency(const CXairoICorpusTextFilter*);
	XAIRO_API_EXPORT bool included(const CXairoIAddkeyFilter*);
	const xairo_uchar* getId();
	int getFilteredFrequencyMap(int,int *);

private:
	xara_form* m_form;
	int m_ptr;
	CXairoServer* m_server;
	int m_d, m_p, m_i;
};


XAIRO_NAMESPACE_END
