#include "stdafx.h"
#include "XairoProxyAddkeyValueList.h"
#include "XairoProxyAddkeyValue.h"

CXairoProxyAddkeyValueList::CXairoProxyAddkeyValueList(const xairo_uchar* id,CXairoProxyServer* s):
	m_id(id),m_server(s)
{
}

CXairoProxyAddkeyValueList::~CXairoProxyAddkeyValueList(void)
{
}

int CXairoProxyAddkeyValueList::getCount()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("AddkeyValueList_getCount"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

CXairoIAddkeyValue* CXairoProxyAddkeyValueList::getAddkeyValue(int i)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("AddkeyValueList_getAddkeyValue"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar* v=RPCStringParam(d,0);
	int f=RPCIntParam(d,1);
	return new CXairoProxyAddkeyValue(v,f);

}

