#pragma once
#include "XairoProxyServer.h"

class CXairoProxyAttributeValue :
	public CXairoIAttributeValue
{
public:
	CXairoProxyAttributeValue(const xairo_uchar* v,const xairo_uchar* g,int f,const xairo_uchar* id,CXairoProxyServer* s):
	  m_val(v),m_gloss(g),m_freq(f),m_id(id),m_server(s) {}
	~CXairoProxyAttributeValue(void);
	const xairo_uchar* getValue() {return m_val;}
	int getFrequency() {return m_freq;}
	int getFilteredFrequency(const CXairoICorpusTextFilter*);
	const xairo_uchar* getGloss() {return m_gloss;}
private:
	const xairo_uchar* m_val;
	const xairo_uchar* m_gloss;
	int m_freq;
	const xairo_uchar* m_id;
	CXairoProxyServer* m_server;

};
