#pragma once
#include "XairoProxyServer.h"

class CXairoProxyCorpusText :
	public CXairoICorpusText
{
public:
	CXairoProxyCorpusText(int id,CXairoProxyServer* s):m_id(id),m_server(s) {}
	~CXairoProxyCorpusText(void);
	const xairo_uchar* getTitle();
	CXairoIXpathValue* evalXpath(const xairo_uchar* path);
	int classify(const CXairoIGrammar::Partition* part);
	int getWordCount();
	bool isSelected(CXairoICorpusTextFilter*);
	CXairoITextEntity* getTextEntity();
	int getIndex();
private:
	int m_id;
	CXairoProxyServer* m_server;
};
