#include "stdafx.h"
#include "XairoProxyExtendedForm.h"

const xairo_uchar* CXairoProxyExtendedForm::getAdditionalKey(const xairo_uchar* key)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_I4; x[0].i=m_i;
	x[1].t=XMLRPC_STRING; x[1].s=key;
	s=RPCCall(L("ExtendedForm_getAdditionalKey"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

const xairo_uchar* CXairoProxyExtendedForm::getNorm()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_i;
	s=RPCCall(L("ExtendedForm_getNorm"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}
const xairo_uchar* CXairoProxyExtendedForm::getText()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_i;
	s=RPCCall(L("ExtendedForm_getText"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

const xairo_uchar* CXairoProxyExtendedForm::getData(int i)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_I4; x[0].i=m_i;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("ExtendedForm_getData"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

CXairoIExtendedForm::type CXairoProxyExtendedForm::getType()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_i;
	s=RPCCall(L("ExtendedForm_getType"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return (CXairoIExtendedForm::type) RPCIntParam(d,0);
}


